

double F_calc(double r, double r_eq, double rho, double U_o)
{
	return 4.0*U_o*rho*r/pow(r_eq, 2)*(-1.0*exp(2.0*rho*(1 - pow(r/r_eq, 2))) + exp(1.0*rho*(1 - pow(r/r_eq, 2))));
}

double V_calc(double r, double r_eq, double rho, double U_o)
{
	return U_o*exp(2.0*rho*(1 - pow(r/r_eq, 2))) - 2.0*U_o*exp(1.0*rho*(1 - pow(r/r_eq, 2)));
}

void Record_data(double *Xpos, double *Ypos, double *Zpos, int N, char m)
{
	ofstream myfile;
	myfile.open("dataout.m", ios::app);
	
	myfile<<"X"<<m<<" = [";
	for (int i=0; i<N-1; i++) {
		myfile<<Xpos[i]<<", ";
	}
	myfile<<Xpos[N-1]<<"];"<<endl;
	
	myfile<<"Y"<<m<<" = [";
	for (int i=0; i<N-1; i++) {
		myfile<<Ypos[i]<<", ";
	}
	myfile<<Ypos[N-1]<<"];"<<endl;
	
	myfile<<"Z"<<m<<" = [";
	for (int i=0; i<N-1; i++) {
		myfile<<Zpos[i]<<", ";
	}
	myfile<<Zpos[N-1]<<"];"<<endl;
	
	myfile.close();
}

void Record_Pr(double *Pr, int N)
{		
	ofstream myfile;
	myfile.open("dataout.m", ios::app);
	myfile<<"P_r = [";
	for (int i=0; i<N-1; i++) {
		myfile<<Pr[i]<<", ";
	}
	myfile<<Pr[N-1]<<"];"<<endl;
	myfile.close();
}

void Record_PID(int *P_id, int N)
{		
	ofstream myfile;
	myfile.open("dataout.m", ios::app);
	myfile<<"PID = [";
	for (int i=0; i<N-1; i++) {
		myfile<<P_id[i]<<", ";
	}
	myfile<<P_id[N-1]<<"];"<<endl;
	myfile.close();
}

void Record_Init(double *force_array, double *potential_array, double k_o, double rho, double nu_o, double nu_scaled, double r_eq, double lambda, double U_o, double U_scaled, double ds, int N, int Num_points)
{		
	ofstream* file = new ofstream("dataout.m");
	
	(*file)<<"N = "<<N<<";"<<endl;
	(*file)<<"S.k_o = "<<k_o<<";"<<endl;
	(*file)<<"S.rho = "<<rho<<";"<<endl;
	(*file)<<"S.nu_o = "<<nu_o<<";"<<endl;
	(*file)<<"S.nu_sc = "<<nu_scaled<<";"<<endl;
	(*file)<<"S.e_eq = "<<r_eq<<";"<<endl;
	(*file)<<"S.lambda = "<<lambda<<";"<<endl;
	(*file)<<"S.U_o = "<<U_o<<";"<<endl;
	(*file)<<"S.U_scaled = "<<U_scaled<<";"<<endl;
	(*file)<<"V_total = [];"<<endl;
	(*file)<<"X_move = [];"<<endl;
	int i=0;
	(*file)<<"force_array = [";
	for (i=0; i<Num_points-1; i++) {
		(*file)<<force_array[i]<<", ";
	}
	(*file)<<force_array[Num_points-1]<<"];"<<endl;
	
	(*file)<<"potential_array = [";
	for (i=0; i<Num_points-1; i++) {
		(*file)<<potential_array[i]<<", ";
	}
	(*file)<<potential_array[Num_points-1]<<"];"<<endl;
	
	(*file)<<"r_sim = [";
	for (i=0; i<Num_points-1; i++) {
		(*file)<<i*ds<<", ";
	}
	(*file)<<(Num_points-1)*ds<<"];"<<endl;
	
	file->close();
	delete file;
}