#include <iostream>
#include <fstream>
using namespace std;
#include <math.h>

#include "auxlrs.h"


#include "a_par.h"
#include "b_par.h"
#include "F_par.h"



int main()
{
	
	//=====================================================================================================================================
	// Initialize variable
	int i=0, j=0, k=0, t=0;
	
	//const double D_step = .01;
	
	
	//double Fx = .003*5;
	double f = 0;
	double X_temp = 0, Y_temp = 0, d = 0, R_temp = 0, F_temp = 0;
	double V_total = 0;
	
	
	double* X = new double[N];
	double* Y = new double[N];
	//double* Z = new double[N];
	double* F_array_X = new double[N];
	double* F_array_Y = new double[N];
	//double* F_array_Z = new double[N];
	int* P_id = new int[N];
	
	
	double dfx = 0, dfy = 0;//, dfz = 0;
	
	const double dis_cut = pow(2.5*r_eq, 2);
	double ds_check = 0;
	
	const int Num_points = 10000;
	const int Num_P = 1000;
	double ds = sqrt(dis_cut)/Num_points;
	double ds_square = (dis_cut)/Num_points;
	//double P_ds = sqrt(dis_cut)/Num_P;
	
	double sqrt_array[Num_points];
	double force_array[Num_points];
	double potential_array[Num_points]; 
	double P_r[Num_points]; 
	int count = 0;
	
	
	long * idum = new long;
	*(idum) = 100;
	
	const double dt = 0.0001;
	
	
	//=====================================================================================================================================
	// Assing position for X in a square position
	int id = 0;
	for (i=0; i<Nx; i++){
		for (j=0; j<Ny; j++) {
			
			id = j + i*Ny;
			X[id] = i*r_eq*.85;
			Y[id] = j*r_eq;
			
			if (i == 0 || i == (Nx-1)) {
				P_id[id] = 1;
			}
			else if (i == 6) {
				P_id[id] = 2;
			} 
			else {
				P_id[id] = 0;
			}
			
		}
	}
	
	
	cout << "R_eq = "<< r_eq << endl;
	cout << "N = "<< N << endl;
	cout << "ds = "<< ds << endl;
	cout << "Initialization of Data Complete"<<endl;
	cout << "Now Running Simulation..."<<endl<<endl;
	
	//=====================================================================================================================================
	
	
	for (i=0; i<Num_points; i++) {
		sqrt_array[i] = sqrt(i*ds_square);
		force_array[i] = F_calc(i*ds, r_eq, rho, U_scaled);
		potential_array[i] = V_calc(i*ds, r_eq, rho, U_scaled);
	}
	
	for (i=0;i<Num_P;i++){
		P_r[i] = 0;
	}
	
	//=====================================================================================================================================
	// Create the file
	
	Record_Init(force_array, potential_array, k_o, rho, nu_o, nu_scaled, r_eq, lambda, U_o, U_scaled, ds, N, Num_points);
	Record_data_2D(X, Y, N,'o');
	Record_PID(P_id, N);
	//return 0;
	
	//=====================================================================================================================================
	// Time loop
	for (t=0; t<t_end; t++) {
		
		if ((t/100-t/100.0) == 0){
			cout << "Iteration # " << t << " Percent done " << int((100.0*t)/t_end) << "%"<<endl;
			cout<<"   F = "<<f<<" count is "<<count<<" ratio is "<<ds_check/ds<<endl;
		}
		
		//cout << "Iteration # " << t << " Percent done " << int((100.0*t)/t_end) << "%"<<endl;
		
		// Calculate the distance, calc force, and move particles in the same step
		
		//==============================================================================================
		//Method two: first compute all forces, then move all points
		for (i=0; i<N; i++) {
			F_array_X[i] = 0;
			F_array_Y[i] = 0;
		}
		
		V_total =0;
		for (i=0; i<N; i++) {
			for (j=0; j<N; j++) {
				
				X_temp = X[j] - X[i]; // note j is shifted to the left by X_bc_r
				Y_temp = Y[j] - Y[i];
				d = X_temp*X_temp + Y_temp*Y_temp;
				
				if (d != 0 && d < dis_cut) {
					R_temp = sqrt(d);
					
					F_temp = force_array[int(R_temp/ds)];
					F_array_X[i] += X_temp/R_temp*F_temp;
					F_array_Y[i] += Y_temp/R_temp*F_temp;
					
					V_total += potential_array[int(R_temp/ds)];		
					
				}
				
				
				
			}
		}
		
		
		if (t == 100000){
			Record_data_2D(X, Y, N,'m');
			//f = f_o;
		}
		
		if (t == 300000){
			Record_data_2D(X, Y, N,'c');
			f = F_push;
		}
		
		count = 0;ds_check = 0;
		for (i=0; i<N; i++) {
			if (P_id[i] == 0) {
				//dfx = F_array_X[i]*dt/nu_scaled;
				dfy = F_array_Y[i]*dt/nu_scaled;
				
				//X[i] += dfx;
				Y[i] += dfy;
				
				//(ran2(idum) > 0.50) ? X[i] += D_step : X[i] -= D_step;
				//(ran2(idum) > 0.50) ? Y[i] += D_step : Y[i] -= D_step;
			}
			else if (P_id[i] == 2){
				//X[i] += F_array_X[i]*dt/nu_scaled;
				Y[i] += f*dt + F_array_Y[i]*dt/nu_scaled;
			}
			
			
			
		}
		
		
		
		
		//==============================================================================================
		
		if ((t/t_sample - t/(1.0*t_sample)) == 0){
			ofstream myfile;
			myfile.open("dataout.m", ios::app);
			myfile<<"V_total = [V_total, "<<V_total<<"];"<<endl;
			myfile.close();
		} 
	}
	
	Record_data_2D(X, Y, N,'n');
	Record_Pr(P_r, Num_P);
	
	
	return 0;
	
}
