#include <iostream>
#include <fstream>
using namespace std;
#include <math.h>

#include "auxlrs.h"


#include "a_par.h"
#include "b_par.h"
#include "F_par.h"



int main()
{
	
	//=====================================================================================================================================
	// Initialize variable
	int i=0, j=0, k=0, t=0;
	
	const double D_step = 0;//.01;
	
	
	//double Fx = .003*5;
	double fz = 0;
	double X_temp = 0, Y_temp = 0, Z_temp = 0, d = 0, R_temp = 0, F_temp = 0;
	double V_total = 0;
	
	double* X = new double[N];
	double* Y = new double[N];
	double* Z = new double[N];
	double* F_array_X = new double[N];
	double* F_array_Y = new double[N];
	double* F_array_Z = new double[N];
	int* P_id = new int[N];
	
	const int Tonari_num = 100;
	
	int** Tonari_id = new int*[N];
	
	for (i=0; i<N; i++) {
		Tonari_id[i] = new int[Tonari_num];
	}
	
	
	const double dis_cut = pow(2.5*r_eq, 2);
	double Strain = 1, Zmid = r_eq*Nz/(2.0*sqrt(2.0));
	
	const int Num_points = 10000;
	const int Num_P = 1000;
	double ds = sqrt(dis_cut)/Num_points;
	double ds_square = (dis_cut)/Num_points;
	double P_ds = sqrt(dis_cut)/Num_P;
	
	double sqrt_array[Num_points];
	double force_array[Num_points];
	double potential_array[Num_points]; 
	double P_r[Num_points]; 
	int count = 0;
	
	long * idum = new long;
	*(idum) = 100;
	
	const double dt = 0.001;
	
	
	//=====================================================================================================================================
	// Assing position for X
	int id = 0;
	for (k=0; k<Nz; k++){
		for (i=0; i<Nx; i++) {
			for (j=0; j<Ny; j++) {
				id = k*Nx*Ny + i*Ny + j;
				
				X[id] = (i*r_eq - Nx*r_eq/2.0);
				Y[id] = (j*r_eq - Ny*r_eq/2.0);
				Z[id] = k*r_eq/sqrt(2.0);
				
				if( (k/2 - k/2.0) == 0){
					X[id] += r_eq/2.0;
					Y[id] += r_eq/2.0;
				}
				
				
				if (i == 0){
					P_id[id] = 1; // left side of the structure
				}
				else if(i == Nx-1){
					P_id[id] = 2; // right side of the structure
				}
				else{
					P_id[id] = 0;
				}
			}
		}
	}
	
	// Assing the Tonari mat ID
	for (i=0;i<N;i++){
		for (j=0;j<Tonari_num;j++){
			Tonari_id[i][j] = -1;
		}
	}
	
	
	// Determine the Tonari mat
	for (i=0;i<N;i++){
		count = 0;
		for (j=0;j<N;j++){
			X_temp = X[j] - X[i];
			Y_temp = Y[j] - Y[i];
			Z_temp = Z[j] - Z[i];
			d = sqrt(X_temp*X_temp + Y_temp*Y_temp + Z_temp*Z_temp);
			
			if (d != 0 && d < 2.5*r_eq){
				Tonari_id[i][count] = j;
				count++;
			}
		}
	}
	
	
	cout << "R_eq = "<< r_eq << endl;
	cout << "N = "<< N << endl;
	cout << "ds = "<< ds << endl;
	cout << "Initialization of Data Complete"<<endl;
	cout << "Now Running Simulation..."<<endl<<endl;
	
	//=====================================================================================================================================
	
	
	for (i=0; i<Num_points; i++) {
		sqrt_array[i] = sqrt(i*ds_square);
		force_array[i] = F_calc(i*ds, r_eq, rho, U_scaled);
		potential_array[i] = V_calc(i*ds, r_eq, rho, U_scaled);
	}
	
	for (i=0;i<Num_P;i++){
		P_r[i] = 0;
	}
	
	//=====================================================================================================================================
	// Create the file
	
	Record_Init(force_array, potential_array, k_o, rho, nu_o, nu_scaled, r_eq, lambda, U_o, U_scaled, ds, N, Num_points);
	Record_data(X, Y, Z, N,'o');
	Record_PID(P_id, N);
	//return 0;
	
	//=====================================================================================================================================
	// Time loop
	for (t=0; t<t_end; t++) {
		
		if ((t/100-t/100.0) == 0)
			cout << "Iteration # " << t << " Percent Complete " << int((100.0*t)/t_end) << "%   E = "<<V_total<<"    Strain = "<<Strain<<endl;
		
		
				
		//==============================================================================================
		// First compute all forces, then move all points
		for (i=0; i<N; i++) {
			F_array_X[i] = 0;
			F_array_Y[i] = 0;
			F_array_Z[i] = 0;
		}
		
		V_total = 0;
		
		// Compute all forces for elements in the Tonari mat
		for (i=0;i<N; i++) {
			j=0;
			id = Tonari_id[i][j];
			
			while (id != -1) {
				X_temp = X[id] - X[i];
				Y_temp = Y[id] - Y[i];
				Z_temp = Z[id] - Z[i];
				R_temp = sqrt(X_temp*X_temp + Y_temp*Y_temp + Z_temp*Z_temp);
				
				F_temp = force_array[int(R_temp/ds)];
				F_array_X[i] += X_temp/R_temp*F_temp;
				F_array_Y[i] += Y_temp/R_temp*F_temp;
				F_array_Z[i] += Z_temp/R_temp*F_temp;
				
				V_total += potential_array[int(R_temp/ds)];
				j++;
				id = Tonari_id[i][j];
			}
		}
		
		// Every so often update the tonari mat
		if ((t/100 - t/100.0) == 0){
			for (i=0;i<N;i++){
				for (j=0;j<Tonari_num;j++){
					Tonari_id[i][j] = -1;
				}
			}
			
			for (i=0;i<N;i++){
				count = 0;
				for (j=0;j<N;j++){
					X_temp = X[j] - X[i];
					Y_temp = Y[j] - Y[i];
					Z_temp = Z[j] - Z[i];
					d = sqrt(X_temp*X_temp + Y_temp*Y_temp + Z_temp*Z_temp);
					
					if (d != 0 && d < 2.5*r_eq){
						Tonari_id[i][count] = j;
						count++;
					}
				}
			}
		}
		
		if (t == 10000){
			Record_data(X, Y, Z, N,'m');
			fz = f_zo;
		}
		
		if (t == 70000){
			Record_data(X, Y, Z, N,'c');
			fz = 0;
		}
		
		// Move the particles with the corresponding force
		for (i=0; i<N; i++) {
			if (P_id[i] == 1){
				//X[i] += F_array_X[i]*dt/nu_scaled;
				//Y[i] += F_array_Y[i]*dt/nu_scaled;
			}
			else{
				X[i] += F_array_X[i]*dt/nu_scaled;
				Y[i] += F_array_Y[i]*dt/nu_scaled;
				Z[i] += F_array_Z[i]*dt/nu_scaled + fz*dt/nu_scaled;
			}
		} 
		
		Strain = 0;Zmid = 0;
		for (i=0;i<N;i++){
			if (P_id[i] == 2) {
				Zmid +=Z[i]/(Ny*Nz);
			}
		}
		//Strain = 1-(.5*r_eq*(Nz-1)/sqrt(2.0) - Zmid)/(.5*r_eq*(Nz-1)/sqrt(2.0));
		Strain = (.5*r_eq*(Nz-1)/sqrt(2.0) - Zmid)/(.5*r_eq*(Nz-1)/sqrt(2.0));
		
		
		//==============================================================================================
		
		if ((t/t_sample - t/(1.0*t_sample)) == 0){
			ofstream myfile;
			myfile.open("dataout.m", ios::app);
			myfile<<"V_total = [V_total, "<<V_total<<"];"<<endl;
			if (t>10000)
				myfile<<"Strain = [Strain, "<<Strain<<"];"<<endl;
			myfile.close();
		} 
	}
	
	Record_data(X, Y, Z, N,'n');
	Record_Pr(P_r, Num_P);
	
	
	return 0;
	
}
